<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:tt="http://xmlns.oracle.com/pcbpel/taskservice/tasktype">

<xsl:param name="GENERATE_IN_DEBUG_MODE_PARAM" select="'false'"/>
<xsl:param name="taskVariableNameParam" select="''"/>
<xsl:param name="taskPrefixParam" select="''"/>
<xsl:param name="taskWSDLPrefixParam" select="''"/>
<xsl:param name="switchNameParam" select="''"/>
<xsl:param name="copyPayloadBackParam" select="'false'"/>
<xsl:param name="payloadHasPartParam" select="'false'"/>
<xsl:param name="payloadHasQueryParam" select="'false'"/>

<xsl:template match="/">

<switch name="{$switchNameParam}" 
        xmlns="http://schemas.xmlsoap.org/ws/2003/03/business-process/"
        xmlns:xsd="http://www.w3.org/2001/XMLSchema"
        xmlns:bpelx="http://schemas.oracle.com/bpel/extension"
        xmlns:bpws="http://schemas.xmlsoap.org/ws/2003/03/business-process/">

   <xsl:for-each select="/input/conclusions/conclusion">
   <case condition=
         "bpws:getVariableData('{$taskVariableNameParam}',
                    '/{$taskPrefixParam}:task/{$taskPrefixParam}:state') = 'COMPLETED' and 
          bpws:getVariableData('{$taskVariableNameParam}',
                    '/{$taskPrefixParam}:task/{$taskPrefixParam}:conclusion') = '{@name}'">
      <bpelx:annotation>
         <bpelx:pattern><xsl:text>Task outcome is </xsl:text><xsl:value-of select="@name"/></bpelx:pattern>
      </bpelx:annotation> 

      <sequence>
         <xsl:if test="$GENERATE_IN_DEBUG_MODE_PARAM = 'true'">
            <xsl:text>DEBUG_CASE_</xsl:text>
            <xsl:value-of select="@name"/>
         </xsl:if>
         <xsl:if test="$copyPayloadBackParam = 'true'">
         <assign name="copyPayloadFromTask">
            <copy>
               <from variable="{$taskVariableNameParam}" 
                     query="/{$taskPrefixParam}:task/{$taskPrefixParam}:payload"/>
               <to>
                   <xsl:attribute name="variable">
                      <xsl:value-of select="/input/parameters/payloadVariableParam/@value"/>
                   </xsl:attribute>
                   <xsl:if test="$payloadHasPartParam = 'true'">
                   <xsl:attribute name="part">
                      <xsl:value-of select="/input/parameters/payloadPartParam/@value"/>
                   </xsl:attribute>
                   </xsl:if>
                   <xsl:if test="$payloadHasQueryParam = 'true'">
                   <xsl:attribute name="query">
                      <xsl:value-of select="/input/parameters/payloadQueryParam/@value"/>
                   </xsl:attribute>
                   </xsl:if>
               </to>
            </copy>
         </assign>
         </xsl:if>
       </sequence>
   </case>
   </xsl:for-each>

   <otherwise>
      <bpelx:annotation>
         <bpelx:pattern><xsl:text>Task is EXPIRED, WITHDRAWN or ERRORED</xsl:text></bpelx:pattern>
      </bpelx:annotation> 
      <sequence>
          <xsl:if test="$GENERATE_IN_DEBUG_MODE_PARAM = 'true'">
             <xsl:text>DEBUG_CASE_OTHERWISE</xsl:text>
          </xsl:if>
         <xsl:if test="$copyPayloadBackParam = 'true'">
         <assign name="copyPayloadFromTask">
            <copy>
               <from variable="{$taskVariableNameParam}" 
                     query="/{$taskPrefixParam}:task/{$taskPrefixParam}:payload"/>
               <to>
                   <xsl:attribute name="variable">
                      <xsl:value-of select="/input/parameters/payloadVariableParam/@value"/>
                   </xsl:attribute>
                   <xsl:if test="$payloadHasPartParam = 'true'">
                   <xsl:attribute name="part">
                      <xsl:value-of select="/input/parameters/payloadPartParam/@value"/>
                   </xsl:attribute>
                   </xsl:if>
                   <xsl:if test="$payloadHasQueryParam = 'true'">
                   <xsl:attribute name="query">
                      <xsl:value-of select="/input/parameters/payloadQueryParam/@value"/>
                   </xsl:attribute>
                   </xsl:if>
               </to>
            </copy>
         </assign>
         </xsl:if>
      </sequence>
   </otherwise>

</switch>

</xsl:template>

</xsl:stylesheet>
