<?xml version="1.0"  encoding="ISO-8859-1"?>

<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:task="http://xmlns.oracle.com/pcbpel/taskservice/task"
   xmlns:po="http://xmlns.oracle.com/pcbpel/test/useractivity/po"
   xmlns:msg="http://www.oracle.com/XSL/Transform/java/oracle.tip.pc.services.hw.task.impl.GetMessageFunction"
   xmlns:format="http://www.oracle.com/XSL/Transform/java/oracle.tip.pc.services.hw.task.impl.FormatFunction"
   version="1.0">

<xsl:param name="language" select="en"/>
<xsl:param name="locale" select="en_US"/>
<xsl:param name="country" select="US"/>
<xsl:param name="actionable" select="false"/>
<xsl:param name="assigneeType" select="user"/>
<xsl:variable name="relativeURL" select="/input/task/taskType"/>
<xsl:variable name="messageFunction" select="msg:new($locale, $relativeURL, 'POTask')"/>

<xsl:output method="html"/>

<xsl:template match="/">

<GenericPayload 
   xmlns="http://xmlns.oracle.com/ias/pcbpel/NotificationService"
   xmlns:tns="http://xmlns.oracle.com/ias/pcbpel/NotificationService">
    <EmailPayload>
        <Subject>
                 <xsl:value-of select="/input/task/title"/>
        </Subject>
        <Content>
            <MimeType>text/html</MimeType>
            <ContentBody>
              <HTML>
                 <BODY>
                 <xsl:if test="$assigneeType = 'user'">
                 <xsl:variable name="message" select="msg:getMessage($messageFunction, 'PO_XSLT_ADDRESS')"/>
                 <xsl:variable name="id" select="/input/user/text()"/>
                 <xsl:value-of select="format:format($message, $id)"/>
                 <xsl:message>
                 <xsl:value-of select="/input/user/text()"/>
                 <xsl:value-of select="/input/user"/>
                 <xsl:value-of select="$id"/>
                 </xsl:message>

                 <p>The following purchase order is assigned to you.

                 <TABLE BORDER="1">
                    <TR>
                      <TD>From</TD>
                      <TD>Item Name</TD>
                      <TD>Item Quantity</TD>
                      <TD>Amount</TD>
                      <TD>Shipdate</TD>
                    </TR>
                    <TR>
                      <TD><xsl:value-of select="/input/task/payload/creator"/></TD>
                      <TD><xsl:value-of select="/input/task/payload/itemName"/></TD>
                      <TD><xsl:value-of select="/input/task/payload/itemQuantity"/></TD>
                      <TD><xsl:value-of select="/input/task/payload/amount"/></TD>
                      <TD><xsl:value-of select="/input/task/payload/shipDate"/></TD>
                    </TR>
                 </TABLE>
                 </p>

                 <p>Please act on the task from the 
                      <A>
                        <xsl:attribute name="href">
                           <xsl:value-of select="/input/worklistapplink"/>
                        </xsl:attribute>
                        Worklist Application
                      </A>
                 </p>

                 <xsl:if test="$actionable = 'true'">
                    <p>You can also perform actions from the following links
                    <xsl:for-each select="/input/actionableLinks/conclusion">
                       <p>
                          <A>
                             <xsl:attribute name="href">
                                <xsl:value-of select="href"/>
                             </xsl:attribute>
                             <xsl:value-of select="displayValue"/>
                          </A>
                       </p>
                    </xsl:for-each>
                    </p>
                 </xsl:if>
                 </xsl:if>
                 </BODY>
              </HTML>
           </ContentBody>
        </Content>
    </EmailPayload>
</GenericPayload>



</xsl:template>

</xsl:stylesheet>