<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:param name="partnerLinkParam" select="''"/>
<xsl:param name="taskWSDLPrefixParam" select="''"/>
<xsl:param name="taskManagerMessageParam" select="''"/>
<xsl:param name="taskIdCorrelationSetParam" select="''"/>
<xsl:param name="taskErroredMessageParam" select="''"/>

<xsl:template name="initiateTaskScope" match="/">

      <scope>
         <faultHandlers>
            <catch faultName="{$taskWSDLPrefixParam}:taskErroredFault"
                   faultVariable="{$taskErroredMessageParam}">
               <assign name="markCompletion">
                  <copy>
                     <from variable="{$taskErroredMessageParam}" part="payload"/>
                     <to variable="{$taskManagerMessageParam}" part="payload"/>
                  </copy>
               </assign>
            </catch>
         </faultHandlers>

         <sequence>
            <!--  initiate task -->
            <invoke name="initiateTask" 
                    partnerLink="{$partnerLinkParam}" 
                    portType="{$taskWSDLPrefixParam}:TaskManager" 
                    operation="initiateTask" 
                    inputVariable="{$taskManagerMessageParam}"
                    outputVariable="{$taskManagerMessageParam}">
               <correlations>
                  <correlation set="{$taskIdCorrelationSetParam}" 
                               initiate="yes" pattern="in"/>
               </correlations>
            </invoke>
         </sequence>
      </scope>

</xsl:template>

</xsl:stylesheet>
