<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:bpel="http://schemas.xmlsoap.org/ws/2003/03/business-process/">

<xsl:include href="/oracle/tip/pc/services/hw/task/taskflow/usecases/userActivityTMScope.xsl"/>
<xsl:include href="/oracle/tip/pc/services/hw/task/taskflow/usecases/userActivityInitiateTask.xsl"/>
<xsl:include href="/oracle/tip/pc/services/hw/task/taskflow/usecases/userActivityCommonAssignment.xsl"/>

<!-- Client passed params -->
<xsl:param name="GENERATE_IN_DEBUG_MODE_PARAM" select="'false'"/>
<xsl:param name="partnerLinkParam" select="''"/>
<xsl:param name="scopeNameParam" select="''"/>
<xsl:param name="taskVariableNameParam" select="''"/>

<!-- Generator passed params -->
<xsl:param name="taskPrefixParam" select="''"/>
<xsl:param name="taskManagerInputMessageParam" select="''"/>
<xsl:param name="taskManagerOutputMessageParam" select="''"/>

<xsl:template match="/">

<scope name="{$scopeNameParam}" variableAccessSerializable="no">

   <sequence>
      <assign name="configureTask">
         <copy>
            <from expression=""/>
            <to variable="{$taskVariableNameParam}" query="/{$taskPrefixParam}:task/{$taskPrefixParam}:title"/>
         </copy>
         <copy>
            <from expression="string( 'Test' )"/>
            <to variable="{$taskVariableNameParam}" query="/{$taskPrefixParam}:task/{$taskPrefixParam}:creator"/>
         </copy>
         <copy>
            <from expression="'assignee@acm.org'"/>
            <to variable="{$taskVariableNameParam}" query="/{$taskPrefixParam}:task/{$taskPrefixParam}:assignee"/>
         </copy>
         <copy>
            <from expression="'PT1H'"/>
            <to variable="{$taskVariableNameParam}" query="/{$taskPrefixParam}:task/{$taskPrefixParam}:duration"/>
         </copy>
         <copy>
            <from expression="3"/>
            <to variable="{$taskVariableNameParam}" query="/{$taskPrefixParam}:task/{$taskPrefixParam}:priority"/>
         </copy>
         <copy>
            <from variable=""/>
            <to variable="{$taskVariableNameParam}" query="/{$taskPrefixParam}:task/{$taskPrefixParam}:attachment"/>
         </copy>
      </assign>
      <scope name="UserInteraction" variableAccessSerializable="no">

         <variables>
            <variable name="{$taskManagerInputMessageParam}" messageType="{$taskPrefixParam}:taskMessage"/>
            <variable name="{$taskManagerOutputMessageParam}" messageType="{$taskPrefixParam}:taskMessage"/>
         </variables>

         <sequence>

            <assign name="setPayload">
               <copy>
                  <from variable="{$taskVariableNameParam}"/>
                  <to variable="{$taskManagerInputMessageParam}" part="payload"/>
               </copy>
            </assign>

            <invoke name="initiateTask" partnerLink="{$partnerLinkParam}"
                    portType="{$taskPrefixParam}:TaskManager" operation="initiateTask"
                    inputVariable="{$taskManagerInputMessageParam}"/>

            <receive name="receiveTaskResult" partnerLink="{$partnerLinkParam}"
                     portType="{$taskPrefixParam}:TaskManagerCallback"
                     operation="onTaskResult" variable="{$taskManagerOutputMessageParam}"/>

            <assign name="readPayload">
               <copy>
                  <from variable="{$taskManagerOutputMessageParam}" part="payload"/>
                  <to variable="{$taskVariableNameParam}"/>
               </copy>
            </assign>

         </sequence>

      </scope>

   </sequence>

</scope>

</xsl:template>

</xsl:stylesheet>
