<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:bpel="http://schemas.xmlsoap.org/ws/2003/03/business-process/">

<xsl:include href="/oracle/tip/pc/services/hw/task/taskflow/usecases/parallel/parallelUAScopeCore.xsl"/>
<xsl:include href="/oracle/tip/pc/services/hw/task/taskflow/usecases/userActivityTMScope.xsl"/>
<xsl:include href="/oracle/tip/pc/services/hw/task/taskflow/usecases/userActivityInitiateTask.xsl"/>
<xsl:include href="/oracle/tip/pc/services/hw/task/taskflow/usecases/userActivityCommonAssignment.xsl"/>

<!-- Client passed params -->
<xsl:param name="GENERATE_IN_DEBUG_MODE_PARAM" select="'false'"/>
<xsl:param name="partnerLinkParam" select="''"/>
<xsl:param name="scopeNameParam" select="''"/>
<xsl:param name="taskVariableNameParam" select="''"/>
<xsl:param name="areAssigneesGroupsParam" select="''"/>
<xsl:param name="areReviewersGroupsParam" select="''"/>
<xsl:param name="continueTaskParam" select="'false'"/>
<xsl:param name="taskActionHandlerPartnerLinkParam" select="''"/>
<xsl:param name="conclusionPercentageParam" select="''"/>
<xsl:param name="defaultConclusionParam" select="''"/>
<xsl:param name="earlyCompletionParam" select="'false'"/>

<!-- Generator passed params -->
<xsl:param name="taskPrefixParam" select="''"/>
<xsl:param name="taskWSDLPrefixParam" select="''"/>
<xsl:param name="taskManagerMessageParam" select="''"/>
<xsl:param name="subTaskManagerMessageParam" select="''"/>
<xsl:param name="taskUpdateMessageParam" select="''"/>
<xsl:param name="taskIdCorrelationSetParam" select="''"/>
<xsl:param name="taskErroredMessageParam" select="''"/>
<xsl:param name="assigneeEntitiesParam" select="''"/>
<xsl:param name="reviewerEntitiesParam" select="''"/>
<xsl:param name="conclusionVariablesPrefixParam" select="''"/>
<xsl:param name="numberOfSubTasksVariableParam" select="''"/>
<xsl:param name="conclusionPercentageVariableParam" select="''"/>
<xsl:param name="defaultConclusionVariableParam" select="''"/>
<xsl:param name="completeTaskInputMessage" select="''"/>
<xsl:param name="tempVariableParam" select="'false'"/>
<xsl:param name="taskActionHandlerWSDLPrefixParam" select="''"/>
<xsl:param name="subTaskAssignmentElementParam" select="''"/>
<xsl:param name="initSubTaskMessageParam" select="''"/>

<xsl:template match="/">

<scope xmlns="http://schemas.xmlsoap.org/ws/2003/03/business-process/"
   xmlns:xsd="http://www.w3.org/2001/XMLSchema"
   xmlns:bpws="http://schemas.xmlsoap.org/ws/2003/03/business-process/" 
   xmlns:bpelx="http://schemas.oracle.com/bpel/extension"
   xmlns:task="http://xmlns.oracle.com/pcbpel/taskservice/task"
   xmlns:taskmngr="http://xmlns.oracle.com/pcbpel/taskservice/taskmanager"
   xmlns:taskactionhandler="http://xmlns.oracle.com/pcbpel/taskservice/taskActionHandler"
   xmlns:ora="http://schemas.oracle.com/xpath/extension"
   name="{$scopeNameParam}" variableAccessSerializable="no">
    
   <variables>
      <variable name="{$taskManagerMessageParam}" 
                messageType="{$taskWSDLPrefixParam}:taskMessage"/>
      <variable name="{$numberOfSubTasksVariableParam}" type="xsd:int"/>
      <variable name="{$assigneeEntitiesParam}" 
                element="{$taskWSDLPrefixParam}:assigneeEntities"/>
      <variable name="{$reviewerEntitiesParam}" 
                element="{$taskWSDLPrefixParam}:assigneeEntities"/>
      <variable name="{$taskErroredMessageParam}" 
                messageType="{$taskWSDLPrefixParam}:taskErroredMessage"/>
      <!--variable name="{$conclusionVariablesPrefixParam}Errored" type="xsd:int"/>
      <variable name="{$conclusionVariablesPrefixParam}Withdrawn" type="xsd:int"/>
      <variable name="{$conclusionVariablesPrefixParam}Expired" type="xsd:int"/-->
      <xsl:for-each select="/input/conclusions/conclusion">
      <variable name="{$conclusionVariablesPrefixParam}{@name}" type="xsd:int"/>
      </xsl:for-each>
      <variable name="{$completeTaskInputMessage}"
                messageType="{$taskWSDLPrefixParam}:completeTaskMessage"/>
      <variable name="{$tempVariableParam}" type="xsd:string"/>
      <variable name="{$conclusionPercentageVariableParam}" type="xsd:int"/>
      <variable name="{$defaultConclusionVariableParam}" type="xsd:string"/>
   </variables>
              
   <correlationSets>
      <correlationSet name="{$taskIdCorrelationSetParam}"
                        properties="{$taskWSDLPrefixParam}:taskId"/>
   </correlationSets>

   <sequence>

      <xsl:copy-of select="/input/bpel:assign"/>

      <xsl:call-template name="parallelCore">
         <xsl:with-param name="GENERATE_IN_DEBUG_MODE_PARAM" select="$GENERATE_IN_DEBUG_MODE_PARAM"/>
         <xsl:with-param name="partnerLinkParam" select="$partnerLinkParam"/>
         <xsl:with-param name="scopeNameParam" select="$scopeNameParam"/>
         <xsl:with-param name="taskVariableNameParam" select="$taskVariableNameParam"/>
         <xsl:with-param name="areAssigneesGroupsParam" select="$areAssigneesGroupsParam"/>
         <xsl:with-param name="continueTaskParam" select="$continueTaskParam"/>
         <xsl:with-param name="taskActionHandlerPartnerLinkParam" select="$taskActionHandlerPartnerLinkParam"/>
         <xsl:with-param name="conclusionPercentageParam" select="$conclusionPercentageParam"/>
         <xsl:with-param name="defaultConclusionParam" select="$defaultConclusionParam"/>
         <xsl:with-param name="earlyCompletionParam" select="$earlyCompletionParam"/>
         <xsl:with-param name="taskPrefixParam" select="$taskPrefixParam"/>
         <xsl:with-param name="taskWSDLPrefixParam" select="$taskWSDLPrefixParam"/>
         <xsl:with-param name="taskManagerMessageParam" select="$taskManagerMessageParam"/>
         <xsl:with-param name="subTaskManagerMessageParam" select="$subTaskManagerMessageParam"/>
         <xsl:with-param name="taskUpdateMessageParam" select="$taskUpdateMessageParam"/>
         <xsl:with-param name="taskIdCorrelationSetParam" select="$taskIdCorrelationSetParam"/>
         <xsl:with-param name="taskErroredMessageParam" select="$taskErroredMessageParam"/>
         <xsl:with-param name="assigneeEntitiesParam" select="$assigneeEntitiesParam"/>
         <xsl:with-param name="conclusionVariablesPrefixParam" select="$conclusionVariablesPrefixParam"/>
         <xsl:with-param name="numberOfSubTasksVariableParam" select="$numberOfSubTasksVariableParam"/>
         <xsl:with-param name="conclusionPercentageVariableParam" select="$conclusionPercentageVariableParam"/>
         <xsl:with-param name="defaultConclusionVariableParam" select="$defaultConclusionVariableParam"/>
         <xsl:with-param name="completeTaskInputMessage" select="$completeTaskInputMessage"/>
         <xsl:with-param name="tempVariableParam" select="tempVariableParam"/>
         <xsl:with-param name="taskActionHandlerWSDLPrefixParam" select="$taskActionHandlerWSDLPrefixParam"/>
         <xsl:with-param name="subTaskAssignmentElementParam" select="$subTaskAssignmentElementParam"/>
         <xsl:with-param name="initSubTaskMessageParam" select="$initSubTaskMessageParam"/>
      </xsl:call-template>

      <assign name="readUpdatedTask">
         <!-- Assign task document from the reply from the task manager -->
         <copy>
            <from variable="{$taskManagerMessageParam}" part="payload"/>
            <to variable="{$taskVariableNameParam}"/>
         </copy>
      </assign>

      <xsl:copy-of select="/input/reviewer/bpel:assign"/>

      <!-- Assign task document to the message sent to the task manager -->
      <assign name="setSystemDefinedAttributes">
         <xsl:call-template name="commonAssignment">
            <xsl:with-param name="taskPrefixParam" select="$taskPrefixParam"/>
            <xsl:with-param name="taskVariableNameParam" select="$taskVariableNameParam"/>
            <xsl:with-param name="continueTaskParam" select="$continueTaskParam"/>
         </xsl:call-template>
         <copy>
            <from variable="{$taskVariableNameParam}"/>
            <to variable="{$taskManagerMessageParam}" part="payload"/>
         </copy>
      </assign>

      <xsl:call-template name="initiateTaskScope">
         <xsl:with-param name="partnerLinkParam" select="$partnerLinkParam"/>
         <xsl:with-param name="taskWSDLPrefixParam" select="$taskWSDLPrefixParam"/>
         <xsl:with-param name="taskManagerMessageParam" select="$taskManagerMessageParam"/>
         <xsl:with-param name="taskIdCorrelationSetParam" select="$taskIdCorrelationSetParam"/>
         <xsl:with-param name="taskErroredMessageParam" select="$taskErroredMessageParam"/>
         <xsl:with-param name="continueTaskParam" select="'true'"/>
      </xsl:call-template>

      <xsl:call-template name="mainScope">
         <xsl:with-param name="partnerLinkParam" select="$partnerLinkParam"/>
         <xsl:with-param name="taskActionHandlerPartnerLinkParam"
                         select="$taskActionHandlerPartnerLinkParam"/>
         <xsl:with-param name="taskPrefixParam" select="$taskPrefixParam"/>
         <xsl:with-param name="taskWSDLPrefixParam" select="$taskWSDLPrefixParam"/>
         <xsl:with-param name="taskActionHandlerWSDLPrefixParam"
                         select="$taskActionHandlerWSDLPrefixParam"/>
         <xsl:with-param name="taskManagerMessageParam" select="$taskManagerMessageParam"/>
         <xsl:with-param name="taskUpdateMessageParam" select="$taskUpdateMessageParam"/>
         <xsl:with-param name="taskIdCorrelationSetParam" select="$taskIdCorrelationSetParam"/>
         <xsl:with-param name="taskErroredMessageParam" select="$taskErroredMessageParam"/>
      </xsl:call-template>

      <assign name="readUpdatedTask">
         <!-- Assign task document from the reply from the task manager -->
         <copy>
            <from variable="{$taskManagerMessageParam}" part="payload"/>
            <to variable="{$taskVariableNameParam}"/>
         </copy>
      </assign>

   </sequence>

</scope>

</xsl:template>

</xsl:stylesheet>
