<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:tt="http://xmlns.oracle.com/pcbpel/taskservice/tasktype"
xmlns:bpel="http://schemas.xmlsoap.org/ws/2003/03/business-process/">

<xsl:include href="/oracle/tip/pc/services/hw/task/taskflow/usecases/userActivityTMScope.xsl"/>
<xsl:include href="/oracle/tip/pc/services/hw/task/taskflow/usecases/userActivityInitiateTask.xsl"/>
<xsl:include href="/oracle/tip/pc/services/hw/task/taskflow/usecases/userActivityCommonAssignment.xsl"/>

<!-- Client passed params -->
<xsl:param name="GENERATE_IN_DEBUG_MODE_PARAM" select="'false'"/>
<xsl:param name="partnerLinkParam" select="''"/>
<xsl:param name="routingServicePartnerLinkParam" select="''"/>
<xsl:param name="scopeNameParam" select="''"/>
<xsl:param name="taskVariableNameParam" select="''"/>
<xsl:param name="maxLevelParam" select="''"/>
<xsl:param name="maxTitleParam" select="''"/>
<xsl:param name="maxUserParam" select="''"/>
<xsl:param name="continueTaskParam" select="'false'"/>
<xsl:param name="taskActionHandlerPartnerLinkParam" select="''"/>
<xsl:param name="maxLevelOfEscalationParam" select="'false'"/>
<xsl:param name="maxTitleOfEscalationParam" select="'false'"/>

<!-- Generator passed params -->
<xsl:param name="taskPrefixParam" select="''"/>
<xsl:param name="taskWSDLPrefixParam" select="''"/>
<xsl:param name="routingServiceWSDLPrefixParam" select="''"/>
<xsl:param name="taskManagerMessageParam" select="''"/>
<xsl:param name="taskUpdateMessageParam" select="''"/>
<xsl:param name="taskDoneParam" select="''"/>
<xsl:param name="taskIdCorrelationSetParam" select="''"/>
<xsl:param name="numOfTimesApprovedParam" select="''"/>
<xsl:param name="taskErroredMessageParam" select="''"/>
<xsl:param name="identityServiceWSDLPrefixParam" select="''"/>
<xsl:param name="tempVariableParam" select="'false'"/>
<xsl:param name="taskActionHandlerWSDLPrefixParam" select="''"/>
<xsl:param name="xpathCriteriaParam" select="'false'"/>
<xsl:param name="patternParam" select="''"/>
<xsl:param name="assigneeEntitiesParam" select="''"/>
<xsl:param name="areAssigneesGroupsParam" select="''"/>
<xsl:param name="escalateOnExpirationParam" select="'false'"/>
<xsl:param name="managementChainElementParam" select="''"/>
<xsl:param name="escalateTaskOnExpirationVariableNameParam" select="''"/>
<xsl:param name="expDurationVariableParam" select="''"/>

<xsl:template match="/">

<scope xmlns="http://schemas.xmlsoap.org/ws/2003/03/business-process/"
   xmlns:xsd="http://www.w3.org/2001/XMLSchema"
   xmlns:bpws="http://schemas.xmlsoap.org/ws/2003/03/business-process/" 
   xmlns:bpelx="http://schemas.oracle.com/bpel/extension"
   xmlns:task="http://xmlns.oracle.com/pcbpel/taskservice/task"
   xmlns:taskmngr="http://xmlns.oracle.com/pcbpel/taskservice/taskmanager"
   xmlns:taskroutingservice="http://xmlns.oracle.com/pcbpel/taskservice/taskroutingservice"
   xmlns:taskactionhandler="http://xmlns.oracle.com/pcbpel/taskservice/taskActionHandler"
   xmlns:identityservice="http://xmlns.oracle.com/pcbpel/identityservice/local"
   xmlns:ora="http://schemas.oracle.com/xpath/extension"
   xmlns:orcl="http://www.oracle.com/XSL/Transform/java/oracle.tip.pc.services.functions.ExtFunc"
   name="{$scopeNameParam}" variableAccessSerializable="no">
    
   <variables>
      <variable name="{$taskManagerMessageParam}" 
                messageType="{$taskWSDLPrefixParam}:taskMessage"/>
      <variable name="{$tempVariableParam}" type="xsd:string"/>
      <variable name="{$taskErroredMessageParam}" 
                messageType="{$taskWSDLPrefixParam}:taskErroredMessage"/>
      <variable name="{$numOfTimesApprovedParam}" type="xsd:int"/>

      <xsl:if test="$xpathCriteriaParam = 'true'">
      <variable name="{$taskDoneParam}" type="xsd:boolean"/>
      </xsl:if>

      <xsl:if test="$patternParam = 'EntityList'">
      <variable name="{$assigneeEntitiesParam}" 
                element="{$taskWSDLPrefixParam}:assigneeEntities"/>
      </xsl:if>

      <xsl:if test="$escalateOnExpirationParam = 'true'">
      <variable name="{$escalateTaskOnExpirationVariableNameParam}" 
                messageType="{$routingServiceWSDLPrefixParam}:taskEscalateOnExpirationMessage"/>
      <variable name="{$expDurationVariableParam}" type="xsd:duration"/>
      <variable name="{$managementChainElementParam}" 
                element="{$identityServiceWSDLPrefixParam}:managementChain"/>
      </xsl:if>

   </variables>
       
   <correlationSets>
      <correlationSet name="{$taskIdCorrelationSetParam}"
                        properties="{$taskWSDLPrefixParam}:taskId"/>
   </correlationSets>

   <sequence>

      <xsl:copy-of select="/input/bpel:assign"/>

      <!-- Set the routing and escalation policy -->
      <assign name="setRoutingPolicy">
         <xsl:if test="$patternParam = 'GetManagementChain'">
         <copy>
            <from expression="concat(
'getManagementChain(&quot;', 
string('{$maxLevelParam}'), 
'&quot;,&quot;', 
string('{$maxTitleParam}'), 
'&quot;)')"/>
            <to variable="{$taskVariableNameParam}" query="/{$taskPrefixParam}:task/{$taskPrefixParam}:approvers"/>
         </copy>
         </xsl:if>

         <xsl:if test="$patternParam = 'EntityList'">
         <xsl:choose>
         <xsl:when test="$areAssigneesGroupsParam = 'true()'">
         <copy>
            <from variable="{$assigneeEntitiesParam}" 
                  query="/taskmngr:assigneeEntities/taskmngr:assignee[1]"/>
            <to variable="{$taskVariableNameParam}" query="/{$taskPrefixParam}:task/{$taskPrefixParam}:assigneeGroups[1]"/>
         </copy>
         <copy>
            <from expression="concat('groups(&quot;', orcl:create-delimited-string(ora:getNodes('{$assigneeEntitiesParam}', '/taskmngr:assigneeEntities/taskmngr:assignee[position() > 1]'), '&quot;),groups(&quot;'), '&quot;)')"/>
            <to variable="{$taskVariableNameParam}" query="/{$taskPrefixParam}:task/{$taskPrefixParam}:approvers"/>
         </copy>
         </xsl:when>
         <xsl:otherwise>
         <copy>
            <from variable="{$assigneeEntitiesParam}" 
                        query="/taskmngr:assigneeEntities/taskmngr:assignee[1]"/>
            <to variable="{$taskVariableNameParam}" query="/{$taskPrefixParam}:task/{$taskPrefixParam}:assigneeUsers[1]"/>
         </copy>
         <copy>
            <from expression="concat('users(&quot;', orcl:create-delimited-string(ora:getNodes('{$assigneeEntitiesParam}', '/taskmngr:assigneeEntities/taskmngr:assignee[position() > 1]'), '&quot;),users(&quot;'), '&quot;)')"/>
            <to variable="{$taskVariableNameParam}" query="/{$taskPrefixParam}:task/{$taskPrefixParam}:approvers"/>
         </copy>
         </xsl:otherwise>
         </xsl:choose>
         </xsl:if>

         <xsl:if test="$escalateOnExpirationParam = 'true'">
         <copy>
            <from variable="{$taskVariableNameParam}" query="/{$taskPrefixParam}:task/{$taskPrefixParam}:expirationDuration"/>
            <to variable="{$expDurationVariableParam}"/>
         </copy>
         <copy>
            <from expression="string('{$maxTitleOfEscalationParam}')"/>
            <to variable="{$managementChainElementParam}" query="/{$identityServiceWSDLPrefixParam}:managementChain/{$identityServiceWSDLPrefixParam}:uptoTitle"/>
         </copy>
         <copy>
            <from expression="string('{$maxLevelOfEscalationParam}')"/>
            <to variable="{$managementChainElementParam}" query="/{$identityServiceWSDLPrefixParam}:managementChain/{$identityServiceWSDLPrefixParam}:levels"/>
         </copy>
         </xsl:if>
      </assign>

      <!-- Set the system attributes -->
      <assign name="setSystemDefinedAttributes">
         <xsl:call-template name="commonAssignment">
            <xsl:with-param name="taskPrefixParam" select="$taskPrefixParam"/>
            <xsl:with-param name="taskVariableNameParam" select="$taskVariableNameParam"/>
            <xsl:with-param name="continueTaskParam" select="$continueTaskParam"/>
         </xsl:call-template>


         <xsl:choose>
         <xsl:when test="$escalateOnExpirationParam = 'true'">
         <copy>
             <from expression="string('SEQUENTIAL_WITH_ESCALATION')"/>
             <to variable="{$taskVariableNameParam}" query="/{$taskPrefixParam}:task/{$taskPrefixParam}:pattern"/>
         </copy>
         </xsl:when>
         <xsl:otherwise>
         <copy>
             <from expression="string('SEQUENTIAL')"/>
             <to variable="{$taskVariableNameParam}" query="/{$taskPrefixParam}:task/{$taskPrefixParam}:pattern"/>
         </copy>
         </xsl:otherwise>
         </xsl:choose>
         <copy>
             <from expression="false()"/>
             <to variable="{$taskVariableNameParam}" query="/{$taskPrefixParam}:task/{$taskPrefixParam}:hasSubTasks"/>
         </copy>
         <copy>
            <from expression="number(0)"/>
            <to variable="{$numOfTimesApprovedParam}"/>
         </copy>
         <copy>
            <from variable="{$taskVariableNameParam}"/>
            <to variable="{$taskManagerMessageParam}" part="payload"/>
         </copy>
      </assign>

      <xsl:call-template name="initiateTaskScope">
         <xsl:with-param name="partnerLinkParam" select="$partnerLinkParam"/>
         <xsl:with-param name="taskWSDLPrefixParam" select="$taskWSDLPrefixParam"/>
         <xsl:with-param name="taskManagerMessageParam" select="$taskManagerMessageParam"/>
         <xsl:with-param name="taskIdCorrelationSetParam" select="$taskIdCorrelationSetParam"/>
         <xsl:with-param name="taskErroredMessageParam" select="$taskErroredMessageParam"/>
         <xsl:with-param name="continueTaskParam" select="$continueTaskParam"/>
      </xsl:call-template>

      <!-- Iterate until the task is marked as EXPIRED, COMPLETED, WITHDRAWN or ERRORED -->
      <while condition="bpws:getVariableData('{$taskManagerMessageParam}', 'payload', '/{$taskPrefixParam}:task/{$taskPrefixParam}:state') != 'EXPIRED' and bpws:getVariableData('{$taskManagerMessageParam}', 'payload', '/{$taskPrefixParam}:task/{$taskPrefixParam}:state') != 'COMPLETED' and bpws:getVariableData('{$taskManagerMessageParam}', 'payload', '/{$taskPrefixParam}:task/{$taskPrefixParam}:state') != 'WITHDRAWN' and bpws:getVariableData('{$taskManagerMessageParam}', 'payload', '/{$taskPrefixParam}:task/{$taskPrefixParam}:state') != 'ERRORED'">
          <sequence>

             <xsl:call-template name="mainScope">
                <xsl:with-param name="partnerLinkParam" select="$partnerLinkParam"/>
                <xsl:with-param name="taskActionHandlerPartnerLinkParam"
                                select="$taskActionHandlerPartnerLinkParam"/>
                <xsl:with-param name="taskPrefixParam" select="$taskPrefixParam"/>
                <xsl:with-param name="taskWSDLPrefixParam" select="$taskWSDLPrefixParam"/>
                <xsl:with-param name="taskActionHandlerWSDLPrefixParam"
                                select="$taskActionHandlerWSDLPrefixParam"/>
                <xsl:with-param name="taskManagerMessageParam" select="$taskManagerMessageParam"/>
                <xsl:with-param name="taskUpdateMessageParam" select="$taskUpdateMessageParam"/>
                <xsl:with-param name="taskIdCorrelationSetParam" select="$taskIdCorrelationSetParam"/>
                <xsl:with-param name="taskErroredMessageParam" select="$taskErroredMessageParam"/>
             </xsl:call-template>

             <switch>
                <case>
                   <xsl:attribute name="condition">
                      <xsl:value-of select="/input/parameters/continueRoutingExpressionParam/@value"/>
                   </xsl:attribute>

                   <bpelx:annotation>
                      <bpelx:pattern><xsl:text>Task is COMPLETED and task outcome is one of the outcomes specified in the routing policy</xsl:text></bpelx:pattern>
                   </bpelx:annotation>

                   <sequence>
                      <xsl:choose>
                      <xsl:when test="$xpathCriteriaParam = 'true'">
                      <assign name="evaluateRoutingCriteria">
                         <copy>
                            <from>
                               <xsl:attribute name="expression">
                                  <xsl:value-of select="/input/parameters/xpathParam/@value"/>
                               </xsl:attribute>
                            </from>
                            <to variable="{$taskDoneParam}"/>
                         </copy>
                      </assign>
                      <xsl:if test="$escalateOnExpirationParam = 'true'">
                      <assign name="resetEscalationPolicy">
                         <copy>
                            <from expression="string('{$maxLevelOfEscalationParam}')"/>
                            <to variable="{$managementChainElementParam}" query="/{$identityServiceWSDLPrefixParam}:managementChain/{$identityServiceWSDLPrefixParam}:levels"/>
                         </copy>
                      </assign>
                      </xsl:if>
                      <assign name="setSystemDefinedAttributes">
                         <copy>
                            <from expression="bpws:getVariableData('{$numOfTimesApprovedParam}') + 1"/>
                            <to variable="{$numOfTimesApprovedParam}"/>
                         </copy>
                      </assign>

                      <switch>
                         <case condition="not(bpws:getVariableData('{$taskDoneParam}'))">

                            <bpelx:annotation>
                               <bpelx:pattern><xsl:text>All the routing criteria is satisfied</xsl:text></bpelx:pattern>
                            </bpelx:annotation>

                            <sequence>
                               <scope name="routeTask">
                                  <faultHandlers>
                                     <catch faultName="{$routingServiceWSDLPrefixParam}:taskErroredFault"
                                            faultVariable="{$taskErroredMessageParam}">
                                        <sequence>
                                           <assign name="readErroredTask">
                                              <copy>
                                                 <from variable="{$taskErroredMessageParam}" 
                                                                part="payload"/>
                                                 <to variable="{$taskManagerMessageParam}" 
                                                                part="payload"/>
                                               </copy>
                                           </assign>
                                        </sequence>
                                     </catch>
                                  </faultHandlers>

                                  <sequence>
                                     <!--  Route task -->
                                     <invoke name="routeTask" 
                                             partnerLink="{$routingServicePartnerLinkParam}" 
                                             portType="{$routingServiceWSDLPrefixParam}:TaskRoutingService" 
                                             operation="routeTaskToNextApprover" 
                                             inputVariable="{$taskManagerMessageParam}"
                                             outputVariable="{$taskManagerMessageParam}"/>
                                  </sequence>
                               </scope>
                            </sequence>
                         </case>
                      </switch>
                      </xsl:when>
                      <xsl:otherwise>
                      <xsl:if test="$escalateOnExpirationParam = 'true'">
                      <assign name="updateEscalationPolicy">
                         <copy>
                            <from expression="string('{$maxLevelOfEscalationParam}')"/>
                            <to variable="{$managementChainElementParam}" query="/{$identityServiceWSDLPrefixParam}:managementChain/{$identityServiceWSDLPrefixParam}:levels"/>
                         </copy>
                      </assign>
                      </xsl:if>

                      <assign name="setSystemDefinedAttributes">
                         <copy>
                            <from expression="bpws:getVariableData('{$numOfTimesApprovedParam}') + 1"/>
                            <to variable="{$numOfTimesApprovedParam}"/>
                         </copy>
                      </assign>

                      <scope name="routeTaskToNextApprover">
                         <faultHandlers>
                            <catch faultName="{$routingServiceWSDLPrefixParam}:taskErroredFault"
                                   faultVariable="{$taskErroredMessageParam}">
                               <sequence>
                                  <assign name="readErroredTask">
                                     <copy>
                                        <from variable="{$taskErroredMessageParam}" 
                                              part="payload"/>
                                        <to variable="{$taskManagerMessageParam}" 
                                            part="payload"/>
                                      </copy>
                                  </assign>
                               </sequence>
                            </catch>
                         </faultHandlers>

                         <sequence>
                            <!--  Route task -->
                            <invoke name="routeTaskToNextApprover" 
                                    partnerLink="{$routingServicePartnerLinkParam}" 
                                    portType="{$routingServiceWSDLPrefixParam}:TaskRoutingService" 
                                    operation="routeTaskToNextApprover" 
                                    inputVariable="{$taskManagerMessageParam}"
                                    outputVariable="{$taskManagerMessageParam}"/>
                         </sequence>
                      </scope>
                      </xsl:otherwise>
                      </xsl:choose>
                   </sequence>
                </case>

                <xsl:if test="$escalateOnExpirationParam = 'true'">
                <case condition="bpws:getVariableData('{$taskManagerMessageParam}',
                                                      'payload',
                                                      '/{$taskPrefixParam}:task/{$taskPrefixParam}:state') = 'EXPIRED'">
                   <bpelx:annotation>
                      <bpelx:pattern><xsl:text>Task is EXPIRED</xsl:text></bpelx:pattern>
                   </bpelx:annotation>

                   <scope name="escalateTask">
                      <faultHandlers>
                         <catch faultName="{$routingServiceWSDLPrefixParam}:taskErroredFault"
                                faultVariable="{$taskErroredMessageParam}">
                            <sequence>
                               <assign name="readErroredTask">
                                  <copy>
                                     <from variable="{$taskErroredMessageParam}" 
                                           part="payload"/>
                                     <to variable="{$taskManagerMessageParam}" 
                                         part="payload"/>
                                   </copy>
                               </assign>
                            </sequence>
                         </catch>
                      </faultHandlers>

                      <sequence>
                         <assign name="setEscalationMessage">
                            <copy>
                               <from variable="{$taskManagerMessageParam}" part="payload"/>
                               <to variable="{$escalateTaskOnExpirationVariableNameParam}" part="task"/>
                            </copy>
                            <copy>
                               <from variable="{$managementChainElementParam}"/>
                               <to variable="{$escalateTaskOnExpirationVariableNameParam}" part="managementChain"/>
                            </copy>
                            <copy>
                               <from variable="{$expDurationVariableParam}"/>
                               <to variable="{$escalateTaskOnExpirationVariableNameParam}" part="renewDuration"/>
                            </copy>
                         </assign>

                         <!--  Escalate task -->
                         <invoke name="escalateTask" 
                                 partnerLink="{$routingServicePartnerLinkParam}" 
                                 portType="{$routingServiceWSDLPrefixParam}:TaskRoutingService" 
                                 operation="escalateTaskOnExpiration" 
                                 inputVariable="{$escalateTaskOnExpirationVariableNameParam}"
                                 outputVariable="{$taskManagerMessageParam}"/>

                         <assign name="updateNumberOfTimesEscalated">
                            <copy>
                               <from expression="number(bpws:getVariableData('{$managementChainElementParam}', '/{$identityServiceWSDLPrefixParam}:managementChain/{$identityServiceWSDLPrefixParam}:levels')) - 1"/>
                               <to variable="{$managementChainElementParam}" query="/{$identityServiceWSDLPrefixParam}:managementChain/{$identityServiceWSDLPrefixParam}:levels"/>
                            </copy>
                         </assign>
                      </sequence>
                   </scope>
                </case>
                </xsl:if>

             </switch>
          </sequence>
      </while>

      <!-- Read task document from taskMessage -->
      <assign name="readUpdatedTask">
         <copy>
            <from variable="{$taskManagerMessageParam}" part="payload"/>
            <to variable="{$taskVariableNameParam}"/>
         </copy>
      </assign>

   </sequence>

</scope>

</xsl:template>

</xsl:stylesheet>
