<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template name="initiateTaskScope" match="/">

      <xsl:param name="partnerLinkParam" select="''"/>
      <xsl:param name="taskWSDLPrefixParam" select="''"/>
      <xsl:param name="taskManagerMessageParam" select="''"/>
      <xsl:param name="taskErroredMessageParam" select="''"/>
      <xsl:param name="continueTaskParam" select="'false'"/>
      <xsl:param name="initSubTaskParam" select="'false'"/>
      <xsl:param name="outputTaskManagerMessageParam" select="''"/>

      <xsl:variable name="scopeName">
         <xsl:choose>
            <xsl:when test="$initSubTaskParam = 'true'">initiateSubTaskForEachAssignee</xsl:when>
            <xsl:otherwise>initiateTask</xsl:otherwise>
         </xsl:choose>
      </xsl:variable>

      <scope name="{$scopeName}" xmlns="http://schemas.xmlsoap.org/ws/2003/03/business-process/">
         <faultHandlers>
            <catch faultName="{$taskWSDLPrefixParam}:taskErroredFault"
                   faultVariable="{$taskErroredMessageParam}">
               <assign name="readErroredTask">
                  <copy>
                     <from variable="{$taskErroredMessageParam}" part="payload"/>
                     <xsl:choose>
                     <xsl:when test="$initSubTaskParam = 'true'">
                     <to variable="{$outputTaskManagerMessageParam}" part="payload"/>
                     </xsl:when>
                     <xsl:otherwise>
                     <to variable="{$taskManagerMessageParam}" part="payload"/>
                     </xsl:otherwise>
                     </xsl:choose>
                  </copy>
               </assign>
            </catch>
         </faultHandlers>

         <sequence>

            <xsl:choose>
            <xsl:when test="$initSubTaskParam = 'true'">

            <!--  reinitiate task -->
            <invoke name="initiateSubTaskForEachAssignee" 
                    partnerLink="{$partnerLinkParam}" 
                    portType="{$taskWSDLPrefixParam}:TaskManager" 
                    operation="initiateSubTask" 
                    inputVariable="{$taskManagerMessageParam}"
                    outputVariable="{$outputTaskManagerMessageParam}"/>

            </xsl:when>
            <xsl:otherwise>

            <xsl:choose>
            <xsl:when test="$continueTaskParam = 'true'">
            <!--  reinitiate task -->
            <invoke name="reinitiateTask" 
                    partnerLink="{$partnerLinkParam}" 
                    portType="{$taskWSDLPrefixParam}:TaskManager" 
                    operation="reinitiateTask" 
                    inputVariable="{$taskManagerMessageParam}"
                    outputVariable="{$taskManagerMessageParam}"/>
            </xsl:when>
            <xsl:otherwise>
            <!--  initiate task -->
            <invoke name="initiateTask" 
                    partnerLink="{$partnerLinkParam}" 
                    portType="{$taskWSDLPrefixParam}:TaskManager" 
                    operation="initiateTask" 
                    inputVariable="{$taskManagerMessageParam}"
                    outputVariable="{$taskManagerMessageParam}"/>
            </xsl:otherwise>
            </xsl:choose>

            </xsl:otherwise>
            </xsl:choose>
         </sequence>
      </scope>

</xsl:template>

</xsl:stylesheet>
