<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template name="mainScope" match="/">

          <!-- Client passed params -->
          <xsl:param name="taskActionHandlerPartnerLinkParam" select="''"/>

          <!-- Generator passed params -->
          <xsl:param name="taskActionHandlerWSDLPrefixParam" select="''"/>
          <xsl:param name="taskManagerMessageParam" select="''"/>

          <sequence xmlns="http://schemas.xmlsoap.org/ws/2003/03/business-process/">

             <!-- Invoke the task action handler -->
             <invoke name="initiateTaskActionHandler"
                     partnerLink="{$taskActionHandlerPartnerLinkParam}"
                     portType="{$taskActionHandlerWSDLPrefixParam}:TaskActionHandler" 
                     operation="initiate" 
                     inputVariable="{$taskManagerMessageParam}">
               <correlations>
                  <correlation set="{$taskIdCorrelationSetParam}" 
                               initiate="yes" pattern="out"/>
               </correlations>
            </invoke>

             <receive name="receiveUpdatedTask"
                      partnerLink="{$taskActionHandlerPartnerLinkParam}"
                      portType="{$taskActionHandlerWSDLPrefixParam}:TaskActionHandlerCallback"
                      operation="onTaskCompleted" 
                      variable="{$taskManagerMessageParam}">
                 <correlations>
                    <correlation set="{$taskIdCorrelationSetParam}" initiate="no"/>
                 </correlations>
             </receive>

          </sequence>

</xsl:template>

</xsl:stylesheet>
