package nl.whitehorses.soa.model.hr.entities;

import java.io.Serializable;

import java.sql.Timestamp;


import java.util.Calendar;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.SequenceGenerator;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import javax.xml.bind.annotation.XmlTransient;

@Entity
@NamedQueries({
  @NamedQuery(name = "Employees.findAll", query = "select o from Employees o")
, @NamedQuery(name = "Employees.findOne", query = "select o from Employees o where o.employeeId = :empId")
})
public class Employees implements Serializable {

    @Column(name="COMMISSION_PCT")
    private Double commissionPct;

    @Column(name="DEPARTMENT_ID")
    private Long departmentId;

    @Column(nullable = false, unique = true, length = 25)
    private String email;
    @Id
    @Column(name="EMPLOYEE_ID", nullable = false)
    @SequenceGenerator(sequenceName = "EMPLOYEES_SEQ", allocationSize = 1,
                       initialValue = 1, name="EMP_SEQ")
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "EMP_SEQ")
    private Long employeeId;
    @Column(name="FIRST_NAME", length = 20)
    private String firstName;
    @Column(name="JOB_ID", nullable = false, length = 10)
    private String jobId;
    @Column(name="LAST_NAME", nullable = false, length = 25)
    private String lastName;
    @Column(name="PHONE_NUMBER", length = 20)
    private String phoneNumber;

    @Column(name="HIRE_DATE")
    @Temporal(value = TemporalType.DATE)
    private Calendar hireDate;

    @ManyToOne
    @JoinColumn(name = "DEPARTMENT_ID", updatable = false, insertable = false)
    private Departments department;    

    private Double salary;

    public Employees() {
    }

    public Double getCommissionPct() {
        return commissionPct;
    }

    public void setCommissionPct(Double commissionPct) {
        this.commissionPct = commissionPct;
    }

    public Long getDepartmentId() {
        return departmentId;
    }

    public void setDepartmentId(Long departmentId) {
        this.departmentId = departmentId;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public Long getEmployeeId() {
        return employeeId;
    }

    public void setEmployeeId(Long employeeId) {
        this.employeeId = employeeId;
    }

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public String getJobId() {
        return jobId;
    }

    public void setJobId(String jobId) {
        this.jobId = jobId;
    }

    public String getLastName() {
        return lastName;
    }

    public void setLastName(String lastName) {
        this.lastName = lastName;
    }


    public String getPhoneNumber() {
        return phoneNumber;
    }

    public void setPhoneNumber(String phoneNumber) {
        this.phoneNumber = phoneNumber;
    }

    public Double getSalary() {
        return salary;
    }

    public void setSalary(Double salary) {
        this.salary = salary;
    }


    public void setHireDate(Calendar hireDate) {
        this.hireDate = hireDate;
    }

    public Calendar getHireDate() {
        return hireDate;
    }

    public void setDepartment(Departments department) {
        this.department = department;
    }

    @XmlTransient    
    public Departments getDepartment() {
        return department;
    }
}
